<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import FeaturedAddOnCardTier from '~/components/pricing/featured-add-ons-card-tier.vue';
import {
  Benefits,
  CardGroup,
  Faq,
  FeatureCategories,
  FeaturesAlt,
  FreeTrial,
  GartnerPromo,
  Hero,
  HeroCentered,
  Resources,
  StickyNav,
  VideoFeatures,
} from '~/components/solutions/ai/index.vue';
import NextStepAlt from '~/components/common/next-step-alt.vue';
import { getPageMetadata } from '~/common/meta';
import { LivePreviewMixin } from '~/mixins';
import { UseLocalizedVideoSubtitles } from '~/mixins';
import { mapGitlabDuoPricingCards } from '~/services/gitlab-duo/gitlab-duo';

export default Vue.extend({
  components: {
    Hero,
    HeroCentered,
    FeaturedAddOnCardTier,
    FeatureCategories,
    GartnerPromo,
    NextStepAlt,
    CardGroup,
    Faq,
    Resources,
    FeaturesAlt,
    FreeTrial,
    Benefits,
    VideoFeatures,
    StickyNav,
  },
  mixins: [LivePreviewMixin, UseLocalizedVideoSubtitles],
  async asyncData({ i18n, app, $content }: any) {
    try {
      const json = await $content(i18n.locale, 'gitlab-duo/index').fetch();

      return {
        pricingDuo: await mapGitlabDuoPricingCards(app, i18n.locale),
        json,
      };
    } catch (e) {
      throw new Error(e);
    }
  },

  head(): MetaInfo {
    const metadata = (this as any).json?.metadata;
    return getPageMetadata(
      metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div class="gitlab-duo">
    <Hero v-if="json.hero" v-bind="json.hero" />
    <HeroCentered v-if="json.heroCentered" v-bind="json.heroCentered" />
    <StickyNav v-if="json.sidenav" :links="json.sidenav.hyperlinks"></StickyNav>
    <SlpContainer>
      <Benefits v-if="json.benefits" id="benefits" :data="json.benefits" />
    </SlpContainer>
    <div id="features" data-slippers-scroll-darkmode="true">
      <SlpContainer>
        <FeaturesAlt v-if="json.feature" v-bind="json.feature" />
        <div v-if="json.features">
          <VideoFeatures
            v-for="(section, index) in json.features.sections"
            :key="index"
            :data="section"
            :index="index"
          />
        </div>
      </SlpContainer>
      <GartnerPromo v-if="json.promo" v-bind="json.promo" />
      <SlpContainer>
        <FeatureCategories v-bind="json.categories" />
      </SlpContainer>
    </div>
    <SlpContainer>
      <CardGroup
        id="why-gitlab-duo"
        v-bind="json.why"
        data-slippers-scroll-darkmode="true"
      />
      <div
        id="pricing"
        data-slippers-scroll-darkmode="true"
        class="slp-py-96 slp-pt-32"
        :data-aos="'fade-up'"
        :data-aos-duration="1200"
        :data-aos-offset="200"
      >
        <SlpTypography variant="heading2-bold" tag="h2" class="pricing-header">
          {{ json.pricing?.header }}
        </SlpTypography>
        <SlpRow style="gap: 30px">
          <SlpColumn v-for="(item, index) in pricingDuo.pricing" :key="index">
            <FeaturedAddOnCardTier :data="item" class="slp-mt-32" />
          </SlpColumn>
        </SlpRow>
      </div>
      <Faq id="faq" data-slippers-scroll-darkmode="true" v-bind="json.faq" />
      <FreeTrial
        v-if="json.trial"
        id="free-trial"
        class="slp-mt-96 slp-pb-96"
        data-slippers-scroll-darkmode="true"
        v-bind="json.trial"
      />
      <Resources
        id="resources"
        data-slippers-scroll-darkmode="true"
        :data="json.resources"
      />
      <NextStepAlt class="slp-pt-32" />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.gitlab-duo {
  background: $color-surface-700;

  .pricing-header {
    color: $color-text-50;
  }

  &:deep {
    .side-navigation__wrapper {
      margin-top: $spacing-64 !important;
    }
  }
}
</style>
